/**
 * This is a very simple implementation of a
 * process. How to use it:
 * MyProcess myprocess();
 * myprocess.start();
 * here goes the parent...
 * wait(&status);
 *
 * and you have to extend Process and override
 * the run() method which does nothing
 * if the process creation does not work then
 * an the exception ForkException is raised
 */

#ifndef _PROCESS_CLASS
#define _PROCESS_CLASS

#include <stream.h>

/* the process class */

class Process { /* extend me! */
public:
  Process(){}
  int start(); /* throws ForkException */
  virtual void run() {
    /* override me! */
  }
};

/* and its exception */

class ForkException {
public:
  ForkException(int error);
  ~ForkException();
  char* getMessage();
  friend ostream& operator << (ostream& out,const ForkException& fe);
private:
  char* message;
};

#endif
