/* compile: g++ -Wall -fexceptions -o SimpleShell SimpleShell.cc Process.o */
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stream.h>
#include "Process.h"

/* a simple define for convenience */
#define TRUE 1

class ExecProcess:public Process {
public:
  ExecProcess(char* command):com(command) {}

  /* the run() method, does some useful job */
  virtual void run() {
    cout<<"In the child\n";
    /* exec command */
    execlp(com,com,NULL);
    /* executed only if the exec command fails */
    perror("exec");
  }

private:
  const char* com;
};

int main()
{
  int i=0;
  char tab[1024];

  /* the main loop of our shell */
  while (TRUE) {
    /* print strings and numbers */
    cout<<"prompt "<<i++<<"> ";

    /* read the command line */
    cin>>tab;
	     
    if (tab[0]==0) { /* <Control+D> pressed */
      cerr<<"Bye bye\n";
      exit(0);
    }

    ExecProcess execProcess(tab);
    cout<<"Process object created\n";
    try {
      /* there is a fork inside, and the child does not return */
      execProcess.start();
      /* the parent does a wait */
      cout<<wait(0)<<" done\n";
    }
    catch(ForkException fe) {
      cout<<"Fork failed:"<<fe;
    }
  }

  return 0;
}
